#include <hmg.ch> 

DECLARE WINDOW Rtfm 

*-----------------------------------------
PROCEDURE Rtfm_Init()
*-----------------------------------------
Local  i              := 0
Local  nRow           := 0
Local  nCol           := 0
Local  nTopMost       := 0
Local  nMonitors      := 0
Local  nDesktopWidth  := 0
Local  nDesktopHeight := 0
Public aActiveForms   := {}
Public aControls      := {}

LOAD WINDOW Rtfm

If !File("Rtfm.ini")
  BEGIN INI FILE "Rtfm.ini"
	  SET SECTION 'GUI'   ENTRY 'XPosition' TO 0  
    SET SECTION 'GUI'   ENTRY 'YPosition' TO 0
    SET SECTION 'GUI'   ENTRY 'TopMost'   TO 1 
  END INI
Else 
  BEGIN INI FILE "Rtfm.ini"
    GET nCol        SECTION 'GUI'   ENTRY 'XPosition'
    GET nRow        SECTION 'GUI'   ENTRY 'YPosition'    
    GET nTopMost    SECTION 'GUI'   ENTRY 'TopMost'
EndIf

Rtfm.Col := nCol
Rtfm.Row := nRow 
/*If nTopMost == 1
  Rtfm.TopMost := .T.
Else 
  Rtfm.TopMost := .F.
Endif*/
      
nMonitors := GetSystemMetrics(80)
If nMonitors > 1 
  nDesktopWidth := GetSystemMetrics(78)
  nDesktopHeight := GetSystemMetrics(79)
Else 
  nDesktopWidth := GetDesktopWidth()
  nDesktopHeight := GetDesktopHeight()
EndIf 
    
For i := 1 to len(_HMG_SYSDATA[93])
  If !Empty(_HMG_SYSDATA[93][i])
    AAdd(aActiveForms, { _HMG_SYSDATA[93][i], _HMG_SYSDATA[94][i], 0, 0 })
  Endif  
Next i

Rtfm_ScanForms()
Rtfm.Show()

*-----------------------------------------
PROCEDURE Rtfm_ScanForms()
*-----------------------------------------
Local  i              := 0
Local  cForm          := ""
 
Rtfm.Grid_Forms.DisableUpdate()
Rtfm.Grid_Forms.DeleteAllItems()

aActiveForms := {}

For i := 1 to len(_HMG_SYSDATA[93])
  If !Empty(_HMG_SYSDATA[66][i]) .AND. (_HMG_SYSDATA[66][i] != "Rtfm") .AND. (_HMG_SYSDATA[66][i] != "_HMG_CHILDWAITWINDOW")
    AAdd(aActiveForms, { _HMG_SYSDATA[66][i], _HMG_SYSDATA[67][i], 0, 0 })
  EndIf  
Next i

If len(aActiveForms) > 0
  For i := 1 to len(aActiveForms)
    cForm := aActiveForms[i][1]
    aActiveForms[i][3] := GetProperty(cForm,"Width")
    aActiveForms[i][4] := GetProperty(cForm,"Height")
    Rtfm.Grid_Forms.AddItem({ aActiveForms[i][1], alltrim(str(aActiveForms[i][3])), alltrim(str(aActiveForms[i][4])) })
  Next i
EndIf 

Rtfm.Grid_Forms.EnableUpdate()
    
*-----------------------------------------
PROCEDURE Rtfm_ScanControls(cForm)
*-----------------------------------------
Local  i              := 0
Local  cControl       := ""
Local  nFormHandle    := 0

For i := 1 to len(aActiveForms)
  If cForm == aActiveForms[i][1]
    nFormHandle := aActiveForms[i][2]
    Exit
  EndIf
Next i

aControls := {}  
   
For i := 1 to len(_HMG_SYSDATA[2])
  If !("Dummy" $ _HMG_SYSDATA[2][i]) .AND. nFormHandle == _HMG_SYSDATA[4][i]  
    AAdd(aControls, { _HMG_SYSDATA[2][i], _HMG_SYSDATA[4][i], _HMG_SYSDATA[1][i], 0, 0, 0, 0 })
  EndIf  
Next i

Rtfm.Grid_Controls.DisableUpdate()
Rtfm.Grid_Controls.DeleteAllItems()
  
If len(aControls) > 0
  For i := 1 to len(aControls)
    cControl := aControls[i][1] 
    If !Empty(cControl)
      aControls[i][4] := GetProperty(cForm,cControl,"Width")     
      aControls[i][5] := GetProperty(cForm,cControl,"Height")
      aControls[i][6] := GetProperty(cForm,cControl,"Col")
      aControls[i][7] := GetProperty(cForm,cControl,"Row")
      Rtfm.Grid_Controls.AddItem({ aControls[i][1], aControls[i][3], alltrim(str(aControls[i][4])), alltrim(str(aControls[i][5])), ;
                                      alltrim(str(aControls[i][6])), alltrim(str(aControls[i][7]))})
    EndIf                                  
  Next i
EndIf 
Rtfm.Grid_Controls.EnableUpdate() 

*-----------------------------------------
PROCEDURE ShowControlProperties(cControlName)
*-----------------------------------------
Local  nXPos          := 0
Local  nYPos          := 0
Local  nWidth         := 0
Local  nHeight        := 0
Local  i              := 0
 
If len(aControls) > 0
  For i := 1 to len(aControls)
    If cControlName == aControls[i][1]
      nWidth := aControls[i][4]
      nHeight := aControls[i][5]
      nXPos := aControls[i][6]      
      nYPos := aControls[i][7]
    EndIf
  Next i
EndIf

Rtfm.Text_Width.Value := nWidth 
Rtfm.Text_Height.Value := nHeight
Rtfm.Text_X.Value := nXPos
Rtfm.Text_Y.Value := nYPos                                   
 
*-----------------------------------------
PROCEDURE Rtfm_ApplyChanges()
*-----------------------------------------
Local  cControlName   := Rtfm.Grid_Controls.Cell(Rtfm.Grid_Controls.Value,1)
Local  cFormName      := Rtfm.Grid_Forms.Cell(Rtfm.Grid_Forms.Value,1) 
Local  nXPos          := 0
Local  nYPos          := 0
Local  nWidth         := 0
Local  nHeight        := 0

nWidth := Rtfm.Text_Width.Value 
nHeight := Rtfm.Text_Height.Value
nXPos := Rtfm.Text_X.Value 
nYPos := Rtfm.Text_Y.Value

SetProperty(cFormName,cControlName,"Width",nWidth)
SetProperty(cFormName,cControlName,"Height",nHeight)
SetProperty(cFormName,cControlName,"Row",nYPos)  
SetProperty(cFormName,cControlName,"Col",nXPos)

*-----------------------------------------
PROCEDURE CopyControl() 
*-----------------------------------------
Local  cControlName   := Rtfm.Grid_Controls.Cell(Rtfm.Grid_Controls.Value,1) + "_Copy"
Local  cFormName      := Rtfm.Grid_Forms.Cell(Rtfm.Grid_Forms.Value,1)
Local  cControlType   := Rtfm.Grid_Controls.Cell(Rtfm.Grid_Controls.Value,2) 
Local  nXPos          := 0
Local  nYPos          := 0
Local  nWidth         := 0
Local  nHeight        := 0

nWidth := Rtfm.Text_Width.Value 
nHeight := Rtfm.Text_Height.Value
nXPos := Rtfm.Text_X.Value 
nYPos := Rtfm.Text_Y.Value

DO CASE 
  CASE cControlType == "LABEL"
    DEFINE LABEL &cControlName
      PARENT &cFormName
      ROW    nYPos
      COL    nXPos
      WIDTH  nWidth
      HEIGHT nHeight
      VALUE "Forms"
      BACKCOLOR {192,192,192}
      CENTERALIGN .T.
    END LABEL       
END CASE    

*-----------------------------------------
PROCEDURE TextBoxEnterPressed(cControl)
*-----------------------------------------
Rtfm_ApplyChanges()
DoMethod("Rtfm",cControl,"SetFocus")

*-----------------------------------------
PROCEDURE RTFM_WindowMove()
*-----------------------------------------
Local  nCol       := Rtfm.Col
Local  nRow       := Rtfm.Row

If nCol < 0
  nCol := 0
EndIf 

If nRow < 0
  nRow := 0
EndIf 
     
BEGIN INI FILE "Rtfm.ini"
	SET SECTION 'GUI'   ENTRY 'XPosition' TO nCol  
  SET SECTION 'GUI'   ENTRY 'YPosition' TO nRow 
END INI

*-----------------------------------------
PROCEDURE SaveChangesToFile()
*-----------------------------------------
Local  cForm      := Rtfm.Grid_Forms.Cell(Rtfm.Grid_Forms.Value,1)
Local  cFile      := cForm + ".fmg"

If File(cFile)
  msgdebug("Found the file!")
EndIf 

*-----------------------------------------
PROCEDURE Rtfm_Refresh_Forms()
*-----------------------------------------
Local nForm := GetActiveWindow()
Local cForm := ""
Local i := 0
Local nValue := Rtfm.Grid_Forms.Value
Local cValue := Rtfm.Grid_Forms.Cell(nValue,1)
Local nControlValue := Rtfm.Grid_Controls.Value 
 
Rtfm_ScanForms()

For i := 1 to len(aActiveForms)
  If nForm == aActiveForms[i][2]
    cForm := aActiveForms[i][1]
    nValue := i  
    Exit                         
  EndIf
Next i

If Empty(cForm)
  cForm := cValue
EndIf
        
Rtfm_ScanControls(cForm)
Rtfm.Grid_Forms.Value := nValue  
If cForm != cValue 
  Rtfm.Grid_Controls.Value := 1 
Else 
  Rtfm.Grid_Controls.Value := nControlValue
EndIf    
